﻿Imports OutputCachingDemo.Core.Models
Imports OutputCachingDemo.Core.Repositories
Imports OutputCachingDemo.Infrastructure.Data

Namespace OutputCachingDemo.Infrastructure.Repositories
    Public Class CustomerRepository
        Implements ICustomerRepository
        Private ReadOnly _context As CustomerContext

        Public Sub New(ByVal context As CustomerContext)
            _context = context
        End Sub

        Public Sub Create(ByVal customer As Customer) Implements ICustomerRepository.Create
            _context.Customers.Add(customer)
            _context.SaveChanges()
        End Sub

        Public Function GetTopCustomers() As IList(Of Customer) Implements ICustomerRepository.GetTopCustomers
            Return _context.Customers.ToList()
        End Function
    End Class
End Namespace
