﻿Imports OutputCachingDemo.Core.Models
Imports OutputCachingDemo.Core.Repositories
Imports OutputCachingDemo.Infrastructure.Data
Imports OutputCachingDemo.Infrastructure.Repositories

Namespace OutputCachingDemo.Site
    Public Class CustomersController
        Inherits Controller
        Private ReadOnly _repository As ICustomerRepository

        Public Sub New()
            _repository = New CustomerRepository(New CustomerContext)
        End Sub

        Public Function Create() As ActionResult
            Return View("Create", New Customer)
        End Function

        <AcceptVerbs(HttpVerbs.Post)>
        Public Function Create(ByVal customer As Customer) As ActionResult
            _repository.Create(customer)

            Return View("Details", customer)
        End Function

        <OutputCache(Duration:=60, VaryByParam:="none")>
        Public Function TopCustomers() As ActionResult
            Dim _topCustomers = _repository.GetTopCustomers()
            Return View("TopCustomers", _topCustomers)
        End Function
    End Class
End Namespace